--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    10:47:44 01/27/06
-- Design Name:    
-- Module Name:    M64_1 - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity M64_1 is
    Port ( d : in std_logic_vector(63 downto 0);
           s : in std_logic_vector(6 downto 0);
           o : out std_logic);
end M64_1;

architecture Behavioral of M64_1 is
signal m32 : std_logic_vector(1 downto 0);
begin
o <= not s(6) and ((not s(5) and m32(0)) or (s(5) and m32(1)));
process(d,s)
begin
  case s(4 downto 0) is
    when "00000" => m32(0) <= d(32);
    when "00001" => m32(0) <= d(33);
    when "00010" => m32(0) <= d(34);
    when "00011" => m32(0) <= d(35);
    when "00100" => m32(0) <= d(36);
    when "00101" => m32(0) <= d(37);
    when "00110" => m32(0) <= d(38);
    when "00111" => m32(0) <= d(39);
    when "01000" => m32(0) <= d(40);
    when "01001" => m32(0) <= d(41);
    when "01010" => m32(0) <= d(42);
    when "01011" => m32(0) <= d(43);
    when "01100" => m32(0) <= d(44);
    when "01101" => m32(0) <= d(45);
    when "01110" => m32(0) <= d(46);
    when "01111" => m32(0) <= d(47);
    when "10000" => m32(0) <= d(48);
    when "10001" => m32(0) <= d(49);
    when "10010" => m32(0) <= d(50);
    when "10011" => m32(0) <= d(51);
    when "10100" => m32(0) <= d(52);
    when "10101" => m32(0) <= d(53);
    when "10110" => m32(0) <= d(54);
    when "10111" => m32(0) <= d(55);
    when "11000" => m32(0) <= d(56);
    when "11001" => m32(0) <= d(57);
    when "11010" => m32(0) <= d(58);
    when "11011" => m32(0) <= d(59);
    when "11100" => m32(0) <= d(60);
    when "11101" => m32(0) <= d(61);
    when "11110" => m32(0) <= d(62);
    when others => m32(0) <= d(63);
  end case;
  case s(4 downto 0) is
    when "00000" => m32(1) <= d(0);
    when "00001" => m32(1) <= d(1);
    when "00010" => m32(1) <= d(2);
    when "00011" => m32(1) <= d(3);
    when "00100" => m32(1) <= d(4);
    when "00101" => m32(1) <= d(5);
    when "00110" => m32(1) <= d(6);
    when "00111" => m32(1) <= d(7);
    when "01000" => m32(1) <= d(8);
    when "01001" => m32(1) <= d(9);
    when "01010" => m32(1) <= d(10);
    when "01011" => m32(1) <= d(11);
    when "01100" => m32(1) <= d(12);
    when "01101" => m32(1) <= d(13);
    when "01110" => m32(1) <= d(14);
    when "01111" => m32(1) <= d(15);
    when "10000" => m32(1) <= d(16);
    when "10001" => m32(1) <= d(17);
    when "10010" => m32(1) <= d(18);
    when "10011" => m32(1) <= d(19);
    when "10100" => m32(1) <= d(20);
    when "10101" => m32(1) <= d(21);
    when "10110" => m32(1) <= d(22);
    when "10111" => m32(1) <= d(23);
    when "11000" => m32(1) <= d(24);
    when "11001" => m32(1) <= d(25);
    when "11010" => m32(1) <= d(26);
    when "11011" => m32(1) <= d(27);
    when "11100" => m32(1) <= d(28);
    when "11101" => m32(1) <= d(29);
    when "11110" => m32(1) <= d(30);
    when others => m32(1) <= d(31);
  end case;
end process;

end Behavioral;
